=== ldso/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000,2001 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../
include $(TOPDIR)Rules.mak

ALL_SUBDIRS = ldso libdl util


all:
ifeq ($(strip $(BUILD_UCLIBC_LDSO)),true)
	$(MAKE) -C $(LIBRARY_CACHE) ldso;
else
	echo "Not building ld-uClibc"
endif

shared:
ifeq ($(strip $(BUILD_UCLIBC_LDSO)),true)
	$(MAKE) -C $(LIBRARY_CACHE) libdl;
else
	echo "Not building libdl"
endif

utils:
	$(MAKE) -C $(LIBRARY_CACHE) util;

clean:
	set -e ; for d in $(ALL_SUBDIRS) ; do $(MAKE) -C $$d $@ ; done
	-find . -name '*~' | xargs rm -f
