=== debian/control ===
Source: uclibc
Section: devel
Priority: optional
Maintainer: David Schleef <ds@schleef.org>
Build-Depends: debhelper, bzip2, kernel-source-2.4.16
Standards-Version: 3.5.6

Package: libuclibc-dev
Section: devel
Architecture: arm i386 m68k mips mipsel powerpc sh sparc
Depends: libuclibc0 (= ${Source-Version})
Description: A small implementation of the C library
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.  This package includes header files and development
 libraries necessary to compile applications that use uClibc.

Package: libuclibc0
Section: libs
Architecture: arm i386 m68k mips mipsel powerpc sh sparc
Depends:
Description: A small implementation of the C library
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.  This package provides only the run-time libraries.
 .
 The Debian binary packages for uClibc do not provide the necessary
 components for using uClibc as the primary library on a system,
 as might be done for an embedded system.

Package: uclibc-toolchain
Section: devel
Architecture: arm i386 m68k mips mipsel powerpc sh sparc
Depends: gcc|c-compiler, binutils, ${shlibs:Depends}
Recommends: libuclibc-dev
Conflicts: uclibc-gcc
Replaces: uclibc-gcc
Description: A compiler wrapper for uClibc
 This package includes utilities that function as a toolchain for
 compiling with uClibc instead of the native libc.  The utilities
 have names such as powerpc-uclibc-gcc (depending on the architecture),
 and should behave identically to the base utilities, except that
 they use headers and libraries provided in the libuclibc-dev
 package.  Most utilities are symbolic links to the correct underlying
 utility, although gcc and ld are implemented as wrapper binaries that
 call gcc and ld with the necessary arguments and command line options.
